<?php

/**
 * Copyright (c) 2023 schaal @it UG - info@schaal-24.de
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
*/

class installer_proxmox extends installer_base {
	
	public function install_base() {
		global $install;
		
		$this->swriteln('Installing some packages');
		// update
		system('apt-get update && apt-get -y dist-upgrade');
		// packages
		system('apt-get -y install fail2ban git htop iotop mc ntp pigz sshfs smartmontools software-properties-common tcpdump vim-nox unzip');
		// postfix
		system("echo postfix postfix/mailname string $install[host] | debconf-set-selections");
		system("echo postfix postfix/main_mailer_type string '$install[postfix_type]' | debconf-set-selections");
		system('apt-get -y install postfix');
	}

	public function create_thinpool() {
		global $install;

		$this->swriteln('Creating Thin-Pool');
		system('lvcreate -n '.$install['proxmox_lv'].' -l 99%FREE '.$install['proxmox_vg']);
		system('lvconvert --type thin-pool '.$install['proxmox_vg'].'/'.$install['proxmox_lv']);
	}

	public function install_proxmox() {
		global $install;
		$this->swriteln('Installing Proxmox '.$install['proxmox_version']);
		# install proxmox
		$dist = trim(strtolower($install['distname']));
		file_put_contents('/etc/apt/sources.list', "deb [arch=amd64] http://download.proxmox.com/debian/pve $dist pve-no-subscription\n", FILE_APPEND);	
		system("wget https://enterprise.proxmox.com/debian/proxmox-release-$dist.gpg -O /etc/apt/trusted.gpg.d/proxmox-release-$dist.gpg ");
		system('aptitude -q -y purge firmware-bnx2x firmware-realtek firmware-linux firmware-linux-free firmware-linux-nonfree');
		system("echo samba-common samba-common/dhcp boolean false| debconf-set-selections");
		system('apt-get update && apt -y install proxmox-ve');
	}
	
	public function le() {
		global $install;

		$this->swriteln("Installing Let's Encrypt", 'info');
		$this->_exec("wget -O -  https://get.acme.sh | sh");
		$this->_exec("/root/.acme.sh/acme.sh --set-default-ca --server letsencrypt");
		system('/root/.acme.sh/acme.sh --issue --standalone --keypath /etc/pve/local/pveproxy-ssl.key --fullchainpath /etc/pve/local/pveproxy-ssl.pem --reloadcmd "systemctl restart pveproxy" -d '.$install['host']);
	}

}
?>
